/* PageWindow.c generated by valac 0.41.91, the Vala compiler
 * generated from PageWindow.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* PageWindow is a Gtk.Window with essential functions for hosting a Page.  There may be more than*/
/* one PageWindow in the system, and closing one does not imply exiting the application.*/
/**/
/* PageWindow offers support for hosting a single Page; multiple Pages must be handled by the*/
/* subclass.  A subclass should set current_page to the user-visible Page for it to receive*/
/* various notifications.  It is the responsibility of the subclass to notify Pages when they're*/
/* switched to and from, and other aspects of the Page interface.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>


#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;
typedef struct _PageWindowPrivate PageWindowPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
enum  {
	PAGE_WINDOW_0_PROPERTY,
	PAGE_WINDOW_NUM_PROPERTIES
};
static GParamSpec* page_window_properties[PAGE_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PageWindow {
	GtkWindow parent_instance;
	PageWindowPrivate * priv;
	GtkUIManager* ui;
};

struct _PageWindowClass {
	GtkWindowClass parent_class;
	void (*switched_pages) (PageWindow* self, Page* old_page, Page* new_page);
	void (*set_current_page) (PageWindow* self, Page* page);
	void (*clear_current_page) (PageWindow* self);
};

struct _PageWindowPrivate {
	Page* current_page;
	gint busy_counter;
};


static gint PageWindow_private_offset;
static gpointer page_window_parent_class = NULL;

GType page_window_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
void page_window_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page);
static void page_window_real_switched_pages (PageWindow* self,
                                      Page* old_page,
                                      Page* new_page);
PageWindow* page_window_construct (GType object_type);
Page* page_window_get_current_page (PageWindow* self);
void page_window_set_current_page (PageWindow* self,
                                   Page* page);
static void page_window_real_set_current_page (PageWindow* self,
                                        Page* page);
void page_clear_container (Page* self);
void page_set_container (Page* self,
                         GtkWindow* container);
void page_window_clear_current_page (PageWindow* self);
static void page_window_real_clear_current_page (PageWindow* self);
static gboolean page_window_real_key_press_event (GtkWidget* base,
                                           GdkEventKey* event);
gboolean page_notify_app_key_pressed (Page* self,
                                      GdkEventKey* event);
static gboolean page_window_real_key_release_event (GtkWidget* base,
                                             GdkEventKey* event);
gboolean page_notify_app_key_released (Page* self,
                                       GdkEventKey* event);
static gboolean page_window_real_focus_in_event (GtkWidget* base,
                                          GdkEventFocus* event);
gboolean page_notify_app_focus_in (Page* self,
                                   GdkEventFocus* event);
static gboolean page_window_real_focus_out_event (GtkWidget* base,
                                           GdkEventFocus* event);
gboolean page_notify_app_focus_out (Page* self,
                                    GdkEventFocus* event);
static gboolean page_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
gboolean page_notify_configure_event (Page* self,
                                      GdkEventConfigure* event);
void page_window_set_busy_cursor (PageWindow* self);
void spin_event_loop (void);
void page_window_set_normal_cursor (PageWindow* self);
static void page_window_finalize (GObject * obj);


static inline gpointer
page_window_get_instance_private (PageWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PageWindow_private_offset);
}


static void
page_window_real_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page)
{
}


void
page_window_switched_pages (PageWindow* self,
                            Page* old_page,
                            Page* new_page)
{
#line 33 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->switched_pages (self, old_page, new_page);
#line 156 "PageWindow.c"
}


PageWindow*
page_window_construct (GType object_type)
{
	PageWindow * self = NULL;
#line 36 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) g_object_new (object_type, NULL);
#line 38 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	gtk_widget_add_events ((GtkWidget*) self, (gint) ((GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK) | GDK_STRUCTURE_MASK));
#line 36 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return self;
#line 170 "PageWindow.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 43 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 179 "PageWindow.c"
}


Page*
page_window_get_current_page (PageWindow* self)
{
	Page* result = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 42 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 43 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 43 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp1_;
#line 43 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 199 "PageWindow.c"
}


static void
page_window_real_set_current_page (PageWindow* self,
                                   Page* page)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	Page* _tmp5_;
#line 46 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (page != NULL);
#line 47 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 47 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 219 "PageWindow.c"
		Page* _tmp1_;
#line 48 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 48 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 225 "PageWindow.c"
	}
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	old_page = _tmp3_;
#line 51 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 51 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 51 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv->current_page = _tmp4_;
#line 52 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 52 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	page_set_container (_tmp5_, (GtkWindow*) self);
#line 54 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	page_window_switched_pages (self, old_page, page);
#line 46 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 247 "PageWindow.c"
}


void
page_window_set_current_page (PageWindow* self,
                              Page* page)
{
#line 46 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 46 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->set_current_page (self, page);
#line 259 "PageWindow.c"
}


static void
page_window_real_clear_current_page (PageWindow* self)
{
	Page* _tmp0_;
	Page* old_page = NULL;
	Page* _tmp2_;
	Page* _tmp3_;
#line 58 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 58 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 274 "PageWindow.c"
		Page* _tmp1_;
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		page_clear_container (_tmp1_);
#line 280 "PageWindow.c"
	}
#line 61 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp2_ = self->priv->current_page;
#line 61 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 61 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	old_page = _tmp3_;
#line 62 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 62 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 64 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	page_window_switched_pages (self, old_page, NULL);
#line 57 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (old_page);
#line 296 "PageWindow.c"
}


void
page_window_clear_current_page (PageWindow* self)
{
#line 57 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 57 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	PAGE_WINDOW_GET_CLASS (self)->clear_current_page (self);
#line 307 "PageWindow.c"
}


static gboolean
page_window_real_key_press_event (GtkWidget* base,
                                  GdkEventKey* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
#line 67 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) base;
#line 67 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 330 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-press-event", event, &_tmp3_);
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 339 "PageWindow.c"
	} else {
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 343 "PageWindow.c"
	}
#line 68 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_) {
#line 69 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 69 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 351 "PageWindow.c"
	}
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 357 "PageWindow.c"
		Page* _tmp6_;
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_pressed (_tmp6_, event);
#line 363 "PageWindow.c"
	} else {
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 367 "PageWindow.c"
	}
#line 71 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp4_) {
#line 72 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 72 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 375 "PageWindow.c"
	}
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event != NULL) {
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 381 "PageWindow.c"
	} else {
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 385 "PageWindow.c"
	}
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp7_;
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 391 "PageWindow.c"
}


static gboolean
page_window_real_key_release_event (GtkWidget* base,
                                    GdkEventKey* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkWidget* _tmp1_;
	gboolean _tmp4_ = FALSE;
	Page* _tmp5_;
	gboolean _tmp7_ = FALSE;
#line 77 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) base;
#line 77 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = gtk_window_get_focus ((GtkWindow*) self);
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_entry_get_type ())) {
#line 414 "PageWindow.c"
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = gtk_window_get_focus ((GtkWindow*) self);
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		g_signal_emit_by_name (_tmp2_, "key-release-event", event, &_tmp3_);
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = _tmp3_;
#line 423 "PageWindow.c"
	} else {
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 427 "PageWindow.c"
	}
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_) {
#line 79 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 79 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 435 "PageWindow.c"
	}
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp5_ = self->priv->current_page;
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp5_ != NULL) {
#line 441 "PageWindow.c"
		Page* _tmp6_;
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp6_ = self->priv->current_page;
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp4_ = page_notify_app_key_released (_tmp6_, event);
#line 447 "PageWindow.c"
	} else {
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp4_ = FALSE;
#line 451 "PageWindow.c"
	}
#line 81 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp4_) {
#line 82 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 82 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 459 "PageWindow.c"
	}
#line 84 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event != NULL) {
#line 84 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp7_ = GTK_WIDGET_CLASS (page_window_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 465 "PageWindow.c"
	} else {
#line 84 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp7_ = FALSE;
#line 469 "PageWindow.c"
	}
#line 84 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp7_;
#line 84 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 475 "PageWindow.c"
}


static gboolean
page_window_real_focus_in_event (GtkWidget* base,
                                 GdkEventFocus* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
#line 87 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) base;
#line 87 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 496 "PageWindow.c"
		Page* _tmp2_;
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_in (_tmp2_, event);
#line 502 "PageWindow.c"
	} else {
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 506 "PageWindow.c"
	}
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_) {
#line 89 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 89 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 514 "PageWindow.c"
	}
#line 91 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event != NULL) {
#line 91 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_in_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 520 "PageWindow.c"
	} else {
#line 91 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 524 "PageWindow.c"
	}
#line 91 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp3_;
#line 91 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 530 "PageWindow.c"
}


static gboolean
page_window_real_focus_out_event (GtkWidget* base,
                                  GdkEventFocus* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp3_ = FALSE;
#line 94 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) base;
#line 94 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = self->priv->current_page;
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp1_ != NULL) {
#line 551 "PageWindow.c"
		Page* _tmp2_;
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = self->priv->current_page;
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = page_notify_app_focus_out (_tmp2_, event);
#line 557 "PageWindow.c"
	} else {
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp0_ = FALSE;
#line 561 "PageWindow.c"
	}
#line 95 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_) {
#line 96 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		result = TRUE;
#line 96 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return result;
#line 569 "PageWindow.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event != NULL) {
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp3_ = GTK_WIDGET_CLASS (page_window_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 575 "PageWindow.c"
	} else {
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp3_ = FALSE;
#line 579 "PageWindow.c"
	}
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp3_;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 585 "PageWindow.c"
}


static gboolean
page_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	PageWindow * self;
	gboolean result = FALSE;
	Page* _tmp0_;
	gboolean _tmp2_ = FALSE;
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = (PageWindow*) base;
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->current_page;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_ != NULL) {
#line 605 "PageWindow.c"
		Page* _tmp1_;
#line 103 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp1_ = self->priv->current_page;
#line 103 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		if (page_notify_configure_event (_tmp1_, event)) {
#line 104 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
			result = TRUE;
#line 104 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
			return result;
#line 615 "PageWindow.c"
		}
	}
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (GTK_WIDGET_CLASS (page_window_parent_class)->configure_event != NULL) {
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = GTK_WIDGET_CLASS (page_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), event);
#line 622 "PageWindow.c"
	} else {
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = FALSE;
#line 626 "PageWindow.c"
	}
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	result = _tmp2_;
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	return result;
#line 632 "PageWindow.c"
}


void
page_window_set_busy_cursor (PageWindow* self)
{
	gint _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkCursor* _tmp4_;
#line 110 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 111 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->busy_counter;
#line 111 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv->busy_counter = _tmp0_ + 1;
#line 111 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_ > 0) {
#line 112 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return;
#line 654 "PageWindow.c"
	}
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) self);
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp2_ = gdk_display_get_default ();
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp3_ = gdk_cursor_new_for_display (_tmp2_, GDK_WATCH);
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp4_ = _tmp3_;
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	gdk_window_set_cursor (_tmp1_, _tmp4_);
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 115 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	spin_event_loop ();
#line 670 "PageWindow.c"
}


void
page_window_set_normal_cursor (PageWindow* self)
{
	gint _tmp0_;
	GdkWindow* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GdkCursor* _tmp6_;
#line 118 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_return_if_fail (self != NULL);
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = self->priv->busy_counter;
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	if (_tmp0_ <= 0) {
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		self->priv->busy_counter = 0;
#line 121 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		return;
#line 692 "PageWindow.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp1_ = self->priv->busy_counter;
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		self->priv->busy_counter = _tmp1_ - 1;
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		_tmp2_ = self->priv->busy_counter;
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
		if (_tmp2_ > 0) {
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
			return;
#line 706 "PageWindow.c"
		}
	}
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) self);
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp4_ = gdk_display_get_default ();
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp5_ = gdk_cursor_new_for_display (_tmp4_, GDK_LEFT_PTR);
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp6_ = _tmp5_;
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	gdk_window_set_cursor (_tmp3_, _tmp6_);
#line 126 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 127 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	spin_event_loop ();
#line 723 "PageWindow.c"
}


static void
page_window_class_init (PageWindowClass * klass)
{
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	page_window_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	g_type_class_adjust_private_offset (klass, &PageWindow_private_offset);
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow *, Page*, Page*)) page_window_real_switched_pages;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((PageWindowClass *) klass)->set_current_page = (void (*) (PageWindow *, Page*)) page_window_real_set_current_page;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((PageWindowClass *) klass)->clear_current_page = (void (*) (PageWindow *)) page_window_real_clear_current_page;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget *, GdkEventKey*)) page_window_real_key_press_event;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget *, GdkEventKey*)) page_window_real_key_release_event;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_in_event = (gboolean (*) (GtkWidget *, GdkEventFocus*)) page_window_real_focus_in_event;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget *, GdkEventFocus*)) page_window_real_focus_out_event;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget *, GdkEventConfigure*)) page_window_real_configure_event;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = page_window_finalize;
#line 752 "PageWindow.c"
}


static void
page_window_instance_init (PageWindow * self)
{
	GtkUIManager* _tmp0_;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv = page_window_get_instance_private (self);
#line 28 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_tmp0_ = gtk_ui_manager_new ();
#line 28 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->ui = _tmp0_;
#line 30 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv->current_page = NULL;
#line 31 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self->priv->busy_counter = 0;
#line 770 "PageWindow.c"
}


static void
page_window_finalize (GObject * obj)
{
	PageWindow * self;
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_WINDOW, PageWindow);
#line 28 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (self->ui);
#line 30 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	_g_object_unref0 (self->priv->current_page);
#line 27 "/builddir/build/BUILD/photos-0.2.5/src/PageWindow.vala"
	G_OBJECT_CLASS (page_window_parent_class)->finalize (obj);
#line 786 "PageWindow.c"
}


GType
page_window_get_type (void)
{
	static volatile gsize page_window_type_id__volatile = 0;
	if (g_once_init_enter (&page_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PageWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageWindow), 0, (GInstanceInitFunc) page_window_instance_init, NULL };
		GType page_window_type_id;
		page_window_type_id = g_type_register_static (gtk_window_get_type (), "PageWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		PageWindow_private_offset = g_type_add_instance_private (page_window_type_id, sizeof (PageWindowPrivate));
		g_once_init_leave (&page_window_type_id__volatile, page_window_type_id);
	}
	return page_window_type_id__volatile;
}



