/* AppWindow.c generated by valac 0.41.91, the Vala compiler
 * generated from AppWindow.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* AppWindow is the parent window for most windows in Photos (FullscreenWindow is the exception).*/
/* There are multiple types of AppWindows (LibraryWindow, DirectWindow) for different tasks, but only*/
/* one AppWindow may exist per process.  Thus, if the user closes an AppWindow, the program exits.*/
/**/
/* AppWindow also offers support for going into fullscreen mode.  It handles the interface*/
/* notifications Page is expecting when switching back and forth.*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gee.h>


#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;
typedef struct _PageWindowPrivate PageWindowPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;
typedef struct _AppWindowPrivate AppWindowPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
enum  {
	APP_WINDOW_0_PROPERTY,
	APP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* app_window_properties[APP_WINDOW_NUM_PROPERTIES];

#define TYPE_FULLSCREEN_WINDOW (fullscreen_window_get_type ())
#define FULLSCREEN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FULLSCREEN_WINDOW, FullscreenWindow))
#define FULLSCREEN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FULLSCREEN_WINDOW, FullscreenWindowClass))
#define IS_FULLSCREEN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FULLSCREEN_WINDOW))
#define IS_FULLSCREEN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FULLSCREEN_WINDOW))
#define FULLSCREEN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FULLSCREEN_WINDOW, FullscreenWindowClass))

typedef struct _FullscreenWindow FullscreenWindow;
typedef struct _FullscreenWindowClass FullscreenWindowClass;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_LIBRARY_WINDOW (library_window_get_type ())
#define LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_WINDOW, LibraryWindow))
#define LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_WINDOW, LibraryWindowClass))
#define IS_LIBRARY_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_WINDOW))
#define IS_LIBRARY_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_WINDOW))
#define LIBRARY_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_WINDOW, LibraryWindowClass))

typedef struct _LibraryWindow LibraryWindow;
typedef struct _LibraryWindowClass LibraryWindowClass;

#define TYPE_DIRECT_WINDOW (direct_window_get_type ())
#define DIRECT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECT_WINDOW, DirectWindow))
#define DIRECT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECT_WINDOW, DirectWindowClass))
#define IS_DIRECT_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECT_WINDOW))
#define IS_DIRECT_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECT_WINDOW))
#define DIRECT_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECT_WINDOW, DirectWindowClass))

typedef struct _DirectWindow DirectWindow;
typedef struct _DirectWindowClass DirectWindowClass;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_CHECKERBOARD_PAGE (checkerboard_page_get_type ())
#define CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPage))
#define CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))
#define IS_CHECKERBOARD_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHECKERBOARD_PAGE))
#define IS_CHECKERBOARD_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHECKERBOARD_PAGE))
#define CHECKERBOARD_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHECKERBOARD_PAGE, CheckerboardPageClass))

typedef struct _CheckerboardPage CheckerboardPage;
typedef struct _CheckerboardPageClass CheckerboardPageClass;

#define TYPE_COMMAND_DESCRIPTION (command_description_get_type ())
#define COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescription))
#define IS_COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_DESCRIPTION))
#define COMMAND_DESCRIPTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescriptionIface))

typedef struct _CommandDescription CommandDescription;
typedef struct _CommandDescriptionIface CommandDescriptionIface;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PageWindow {
	GtkWindow parent_instance;
	PageWindowPrivate * priv;
	GtkUIManager* ui;
};

struct _PageWindowClass {
	GtkWindowClass parent_class;
	void (*switched_pages) (PageWindow* self, Page* old_page, Page* new_page);
	void (*set_current_page) (PageWindow* self, Page* page);
	void (*clear_current_page) (PageWindow* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _AppWindow {
	PageWindow parent_instance;
	AppWindowPrivate * priv;
	GtkActionGroup** common_action_groups;
	gint common_action_groups_length1;
	Dimensions dimensions;
	gint pos_x;
	gint pos_y;
	GtkHeaderBar* header;
	GSettings* window_settings;
};

struct _AppWindowClass {
	PageWindowClass parent_class;
	void (*set_default_title) (AppWindow* self);
	void (*build_header_bar) (AppWindow* self);
	void (*on_fullscreen) (AppWindow* self);
	gchar* (*get_app_role) (AppWindow* self);
	void (*on_quit) (AppWindow* self);
	GtkActionGroup** (*create_common_action_groups) (AppWindow* self, int* result_length1);
	void (*update_common_action_availability) (AppWindow* self, Page* old_page, Page* new_page);
	void (*update_common_actions) (AppWindow* self, Page* page, gint selected_count, gint count);
};

struct _AppWindowPrivate {
	GtkActionGroup* common_action_group;
	GtkButton* redo_btn;
	GtkButton* undo_btn;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _CommandDescriptionIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (CommandDescription* self);
	gchar* (*get_explanation) (CommandDescription* self);
};


static gint AppWindow_private_offset;
static gpointer app_window_parent_class = NULL;
extern AppWindow* app_window_instance;
AppWindow* app_window_instance = NULL;
static FullscreenWindow* app_window_fullscreen_window;
static FullscreenWindow* app_window_fullscreen_window = NULL;
static CommandManager* app_window_command_manager;
static CommandManager* app_window_command_manager = NULL;

GType page_window_get_type (void) G_GNUC_CONST;
GType page_get_type (void) G_GNUC_CONST;
GType app_window_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType fullscreen_window_get_type (void) G_GNUC_CONST;
gpointer command_manager_ref (gpointer instance);
void command_manager_unref (gpointer instance);
GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_command_manager (GValue* value,
                                gpointer v_object);
void value_take_command_manager (GValue* value,
                                 gpointer v_object);
gpointer value_get_command_manager (const GValue* value);
GType command_manager_get_type (void) G_GNUC_CONST;
#define APP_WINDOW_DND_ICON_SCALE 128
AppWindow* app_window_construct (GType object_type);
PageWindow* page_window_construct (GType object_type);
void app_window_set_default_title (AppWindow* self);
GType library_window_get_type (void) G_GNUC_CONST;
GType direct_window_get_type (void) G_GNUC_CONST;
#define COMMAND_MANAGER_DEFAULT_DEPTH 20
CommandManager* command_manager_new (gint depth);
CommandManager* command_manager_construct (GType object_type,
                                           gint depth);
static void app_window_on_command_manager_altered (AppWindow* self);
static void _app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                     gboolean can_undo,
                                                                     gboolean can_redo,
                                                                     gpointer self);
GtkActionGroup** app_window_create_common_action_groups (AppWindow* self,
                                                         int* result_length1);
gchar* build_dummy_ui_string (GtkActionGroup** groups,
                              int groups_length1);
void app_window_build_header_bar (AppWindow* self);
static void app_window_real_set_default_title (AppWindow* self);
#define RESOURCES_APP_TITLE _ ("Photos")
static void app_window_real_build_header_bar (AppWindow* self);
GtkAction* app_window_get_common_action (AppWindow* self,
                                         const gchar* name);
static GtkActionEntry* app_window_create_common_actions (AppWindow* self,
                                                  int* result_length1);
void app_window_on_quit (AppWindow* self);
static void _app_window_on_quit_gtk_action_callback (GtkAction* action,
                                              gpointer self);
void app_window_on_fullscreen (AppWindow* self);
static void _app_window_on_fullscreen_gtk_action_callback (GtkAction* action,
                                                    gpointer self);
static void app_window_on_undo (AppWindow* self);
static void _app_window_on_undo_gtk_action_callback (GtkAction* action,
                                              gpointer self);
static void app_window_on_redo (AppWindow* self);
static void _app_window_on_redo_gtk_action_callback (GtkAction* action,
                                              gpointer self);
#define RESOURCES_JUMP_TO_FILE_MENU _ ("File Mana_ger")
void app_window_on_jump_to_file (AppWindow* self);
static void _app_window_on_jump_to_file_gtk_action_callback (GtkAction* action,
                                                      gpointer self);
#define RESOURCES_SELECT_ALL_MENU _ ("Select _All")
static void app_window_on_select_all (AppWindow* self);
static void _app_window_on_select_all_gtk_action_callback (GtkAction* action,
                                                    gpointer self);
#define TRANSLATABLE "translatable"
static void app_window_on_select_none (AppWindow* self);
static void _app_window_on_select_none_gtk_action_callback (GtkAction* action,
                                                     gpointer self);
static void _vala_array_add1 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add2 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add3 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add4 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add5 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add6 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void _vala_array_add7 (GtkActionEntry* * array,
                       int* length,
                       int* size,
                       const GtkActionEntry* value);
static void app_window_real_on_fullscreen (AppWindow* self);
gboolean app_window_has_instance (void);
AppWindow* app_window_get_instance (void);
FullscreenWindow* app_window_get_fullscreen (void);
GtkBuilder* app_window_create_builder (void);
void app_window_error_message (const gchar* message,
                               GtkWindow* parent);
void app_window_error_message_with_title (const gchar* title,
                                          const gchar* message,
                                          GtkWindow* parent,
                                          gboolean should_escape);
gchar* build_alert_body_text (const gchar* primary_text,
                              const gchar* secondary_text,
                              gboolean should_escape);
gboolean app_window_negate_affirm_question (const gchar* message,
                                            const gchar* negative,
                                            const gchar* affirmative,
                                            const gchar* title,
                                            GtkWindow* parent);
GtkResponseType app_window_negate_affirm_cancel_question (const gchar* message,
                                                          const gchar* negative,
                                                          const gchar* affirmative,
                                                          const gchar* title,
                                                          GtkWindow* parent);
GtkResponseType app_window_affirm_cancel_negate_question (const gchar* message,
                                                          const gchar* affirmative,
                                                          const gchar* negative,
                                                          const gchar* title,
                                                          GtkWindow* parent);
GtkResponseType app_window_affirm_cancel_question (const gchar* message,
                                                   const gchar* affirmative,
                                                   const gchar* title,
                                                   GtkWindow* parent);
GtkResponseType app_window_cancel_affirm_question (const gchar* message,
                                                   const gchar* affirmative,
                                                   const gchar* title,
                                                   GtkWindow* parent);
GtkResponseType app_window_negate_affirm_all_cancel_question (const gchar* message,
                                                              const gchar* negative,
                                                              const gchar* affirmative,
                                                              const gchar* affirmative_all,
                                                              const gchar* title,
                                                              GtkWindow* parent);
GQuark database_error_quark (void);
void app_window_database_error (GError* err);
void app_window_panic (const gchar* msg);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
void application_panic (Application* self);
gchar* app_window_get_app_role (AppWindow* self);
static gchar* app_window_real_get_app_role (AppWindow* self);
static void app_window_real_on_quit (AppWindow* self);
void application_exit (Application* self);
Page* page_window_get_current_page (PageWindow* self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType view_collection_get_type (void) G_GNUC_CONST;
ViewCollection* page_get_view (Page* self);
gint view_collection_get_selected_count (ViewCollection* self);
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType data_view_get_type (void) G_GNUC_CONST;
DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
DataSource* data_view_get_source (DataView* self);
void app_window_show_file_uri (AppWindow* self,
                               GFile* file,
                               GError** error);
GFile* media_source_get_master_file (MediaSource* self);
gchar* resources_jump_to_file_failed (GError* err);
static void app_window_real_destroy (GtkWidget* base);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void app_window_show_uri (AppWindow* self,
                          const gchar* url,
                          GError** error);
void sys_show_uri (GdkScreen* screen,
                   const gchar* uri,
                   GError** error);
static GtkActionGroup** app_window_real_create_common_action_groups (AppWindow* self,
                                                              int* result_length1);
static void _vala_array_add8 (GtkActionGroup** * array,
                       int* length,
                       int* size,
                       GtkActionGroup* value);
GtkActionGroup** app_window_get_common_action_groups (AppWindow* self,
                                                      int* result_length1);
static GtkActionGroup** _vala_array_dup1 (GtkActionGroup** self,
                                   int length);
void app_window_go_fullscreen (AppWindow* self,
                               Page* page);
FullscreenWindow* fullscreen_window_new (Page* page);
FullscreenWindow* fullscreen_window_construct (GType object_type,
                                               Page* page);
void page_switching_to_fullscreen (Page* self,
                                   FullscreenWindow* fsw);
void app_window_end_fullscreen (AppWindow* self);
void page_returning_from_fullscreen (Page* self,
                                     FullscreenWindow* fsw);
void app_window_set_common_action_sensitive (AppWindow* self,
                                             const gchar* name,
                                             gboolean sensitive);
void app_window_set_common_action_visible (AppWindow* self,
                                           const gchar* name,
                                           gboolean visible);
static void app_window_real_switched_pages (PageWindow* base,
                                     Page* old_page,
                                     Page* new_page);
void app_window_update_common_action_availability (AppWindow* self,
                                                   Page* old_page,
                                                   Page* new_page);
static void app_window_on_update_common_actions (AppWindow* self);
static void _app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            GeeIterable* removed,
                                                                            gpointer self);
static void _app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                                   gpointer self);
static void _app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                               GeeIterable* changed,
                                                                               gpointer self);
void app_window_update_common_actions (AppWindow* self,
                                       Page* page,
                                       gint selected_count,
                                       gint count);
gint data_collection_get_count (DataCollection* self);
void page_window_switched_pages (PageWindow* self,
                                 Page* old_page,
                                 Page* new_page);
static void app_window_real_update_common_action_availability (AppWindow* self,
                                                        Page* old_page,
                                                        Page* new_page);
GType checkerboard_page_get_type (void) G_GNUC_CONST;
static void app_window_real_update_common_actions (AppWindow* self,
                                            Page* page,
                                            gint selected_count,
                                            gint count);
void app_window_decorate_undo_action (AppWindow* self);
void app_window_decorate_redo_action (AppWindow* self);
CommandManager* app_window_get_command_manager (void);
GType command_description_get_type (void) G_GNUC_CONST;
static void app_window_decorate_command_manager_action (AppWindow* self,
                                                 const gchar* name,
                                                 GtkButton* button,
                                                 const gchar* default_explanation,
                                                 CommandDescription* desc);
gchar* command_description_get_name (CommandDescription* self);
CommandDescription* command_manager_get_undo_description (CommandManager* self);
CommandDescription* command_manager_get_redo_description (CommandManager* self);
gboolean command_manager_undo (CommandManager* self);
gboolean command_manager_redo (CommandManager* self);
void view_collection_select_all (ViewCollection* self);
void view_collection_unselect_all (ViewCollection* self);
static gboolean app_window_real_configure_event (GtkWidget* base,
                                          GdkEventConfigure* event);
static GObject * app_window_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties);
#define GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME "io.elementary.photos"
#define GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_ROOT_SCHEMA_NAME ".preferences"
#define GSETTINGS_CONFIGURATION_ENGINE_WINDOW_PREFS_SCHEMA_NAME GSETTINGS_CONFIGURATION_ENGINE_PREFS_SCHEMA_NAME ".window"
static void app_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
app_window_get_instance_private (AppWindow* self)
{
	return G_STRUCT_MEMBER_P (self, AppWindow_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 597 "AppWindow.c"
}


static void
_app_window_on_command_manager_altered_command_manager_altered (CommandManager* _sender,
                                                                gboolean can_undo,
                                                                gboolean can_redo,
                                                                gpointer self)
{
#line 90 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_command_manager_altered ((AppWindow*) self);
#line 609 "AppWindow.c"
}


AppWindow*
app_window_construct (GType object_type)
{
	AppWindow * self = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	GtkHeaderBar* _tmp2_;
	GtkHeaderBar* _tmp3_;
	GtkHeaderBar* _tmp4_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp5_;
	GtkCssProvider* _tmp6_;
	GdkScreen* _tmp7_;
	GtkCssProvider* _tmp8_;
	gboolean maximized = FALSE;
	Dimensions _tmp15_;
	gint _tmp16_;
	Dimensions _tmp17_;
	gint _tmp18_;
	gboolean _tmp19_;
	CommandManager* _tmp20_;
	CommandManager* _tmp21_;
	CommandManager* _tmp22_;
	gint _tmp23_;
	GtkActionGroup** _tmp24_;
	GtkActionGroup** _tmp25_;
	gint _tmp25__length1;
	GtkUIManager* _tmp34_;
	GtkUIManager* _tmp35_;
	GtkAccelGroup* _tmp36_;
	GError * _inner_error_ = NULL;
#line 53 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = (AppWindow*) page_window_construct (object_type);
#line 55 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 55 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_assert (_tmp0_ == NULL, "instance == null");
#line 56 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (self);
#line 56 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (app_window_instance);
#line 56 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_instance = _tmp1_;
#line 57 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_icon_name ((GtkWindow*) self, "multimedia-photo-manager");
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 59 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->header = _tmp2_;
#line 60 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = self->header;
#line 60 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_header_bar_set_show_close_button (_tmp3_, TRUE);
#line 61 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = self->header;
#line 61 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp4_);
#line 63 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_set_default_title (self);
#line 65 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = gtk_css_provider_new ();
#line 65 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	css_provider = _tmp5_;
#line 66 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = css_provider;
#line 66 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_css_provider_load_from_resource (_tmp6_, "io/elementary/photos/application.css");
#line 67 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = gdk_screen_get_default ();
#line 67 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = css_provider;
#line 67 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 69 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	maximized = FALSE;
#line 72 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (self, TYPE_LIBRARY_WINDOW)) {
#line 694 "AppWindow.c"
		GSettings* _tmp9_;
		GSettings* _tmp10_;
		GSettings* _tmp11_;
#line 73 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp9_ = self->window_settings;
#line 73 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		maximized = g_settings_get_boolean (_tmp9_, "library-maximize");
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp10_ = self->window_settings;
#line 74 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.width = g_settings_get_int (_tmp10_, "library-width");
#line 75 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp11_ = self->window_settings;
#line 75 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.height = g_settings_get_int (_tmp11_, "library-height");
#line 710 "AppWindow.c"
	} else {
		GSettings* _tmp12_;
		GSettings* _tmp13_;
		GSettings* _tmp14_;
#line 77 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_vala_assert (G_TYPE_CHECK_INSTANCE_TYPE (self, TYPE_DIRECT_WINDOW), "this is DirectWindow");
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp12_ = self->window_settings;
#line 78 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		maximized = g_settings_get_boolean (_tmp12_, "direct-maximize");
#line 79 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp13_ = self->window_settings;
#line 79 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.width = g_settings_get_int (_tmp13_, "direct-width");
#line 80 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp14_ = self->window_settings;
#line 80 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.height = g_settings_get_int (_tmp14_, "direct-height");
#line 729 "AppWindow.c"
	}
#line 83 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp15_ = self->dimensions;
#line 83 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp16_ = _tmp15_.width;
#line 83 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp17_ = self->dimensions;
#line 83 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp18_ = _tmp17_.height;
#line 83 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, _tmp16_, _tmp18_);
#line 85 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp19_ = maximized;
#line 85 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp19_) {
#line 86 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_window_maximize ((GtkWindow*) self);
#line 747 "AppWindow.c"
	}
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp20_ = app_window_command_manager;
#line 88 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_assert (_tmp20_ == NULL, "command_manager == null");
#line 89 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp21_ = command_manager_new (COMMAND_MANAGER_DEFAULT_DEPTH);
#line 89 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_command_manager_unref0 (app_window_command_manager);
#line 89 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_command_manager = _tmp21_;
#line 90 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp22_ = app_window_command_manager;
#line 90 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_signal_connect_object (_tmp22_, "altered", (GCallback) _app_window_on_command_manager_altered_command_manager_altered, self, 0);
#line 97 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp24_ = app_window_create_common_action_groups (self, &_tmp23_);
#line 97 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 97 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->common_action_groups = _tmp24_;
#line 97 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->common_action_groups_length1 = _tmp23_;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp25_ = self->common_action_groups;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp25__length1 = self->common_action_groups_length1;
#line 775 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		group_collection = _tmp25_;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		group_collection_length1 = _tmp25__length1;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		for (group_it = 0; group_it < _tmp25__length1; group_it = group_it + 1) {
#line 787 "AppWindow.c"
			GtkActionGroup* _tmp26_;
			GtkActionGroup* group = NULL;
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
			_tmp26_ = _g_object_ref0 (group_collection[group_it]);
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
			group = _tmp26_;
#line 794 "AppWindow.c"
			{
				GtkUIManager* _tmp27_;
				GtkActionGroup* _tmp28_;
#line 99 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp27_ = ((PageWindow*) self)->ui;
#line 99 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp28_ = group;
#line 99 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				gtk_ui_manager_insert_action_group (_tmp27_, _tmp28_, 0);
#line 98 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_g_object_unref0 (group);
#line 806 "AppWindow.c"
			}
		}
	}
	{
		GtkUIManager* _tmp29_;
		GtkActionGroup** _tmp30_;
		gint _tmp30__length1;
		gchar* _tmp31_;
		gchar* _tmp32_;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp29_ = ((PageWindow*) self)->ui;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp30_ = self->common_action_groups;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp30__length1 = self->common_action_groups_length1;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp31_ = build_dummy_ui_string (_tmp30_, _tmp30__length1);
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp32_ = _tmp31_;
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_ui_manager_add_ui_from_string (_tmp29_, _tmp32_, (gssize) -1, &_inner_error_);
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_free0 (_tmp32_);
#line 102 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 832 "AppWindow.c"
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp33_;
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		err = _inner_error_;
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_inner_error_ = NULL;
#line 104 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp33_ = err->message;
#line 104 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_error ("AppWindow.vala:104: Unable to add AppWindow UI: %s", _tmp33_);
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_error_free0 (err);
#line 851 "AppWindow.c"
	}
	__finally8:
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (css_provider);
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_clear_error (&_inner_error_);
#line 101 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return NULL;
#line 864 "AppWindow.c"
	}
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp34_ = ((PageWindow*) self)->ui;
#line 107 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_ui_manager_ensure_update (_tmp34_);
#line 108 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp35_ = ((PageWindow*) self)->ui;
#line 108 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp36_ = gtk_ui_manager_get_accel_group (_tmp35_);
#line 108 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_add_accel_group ((GtkWindow*) self, _tmp36_);
#line 110 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_build_header_bar (self);
#line 53 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (css_provider);
#line 53 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return self;
#line 882 "AppWindow.c"
}


static void
app_window_real_set_default_title (AppWindow* self)
{
#line 114 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _ (RESOURCES_APP_TITLE));
#line 891 "AppWindow.c"
}


void
app_window_set_default_title (AppWindow* self)
{
#line 113 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 113 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->set_default_title (self);
#line 902 "AppWindow.c"
}


static void
app_window_real_build_header_bar (AppWindow* self)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkAction* _tmp2_;
	GtkAction* _tmp3_;
	GtkButton* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkAction* _tmp9_;
	GtkAction* _tmp10_;
	GtkButton* _tmp11_;
	GtkImage* _tmp12_;
	GtkImage* _tmp13_;
	GtkHeaderBar* _tmp14_;
	GtkButton* _tmp15_;
	GtkHeaderBar* _tmp16_;
	GtkButton* _tmp17_;
#line 118 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = (GtkButton*) gtk_button_new ();
#line 118 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 118 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->priv->redo_btn);
#line 118 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->priv->redo_btn = _tmp0_;
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = self->priv->redo_btn;
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = app_window_get_common_action (self, "CommonRedo");
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_activatable_set_related_action ((GtkActivatable*) _tmp1_, _tmp3_);
#line 119 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp3_);
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = self->priv->redo_btn;
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-redo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp6_);
#line 120 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = (GtkButton*) gtk_button_new ();
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp7_);
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->priv->undo_btn);
#line 122 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->priv->undo_btn = _tmp7_;
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = self->priv->undo_btn;
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = app_window_get_common_action (self, "CommonUndo");
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = _tmp9_;
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_activatable_set_related_action ((GtkActivatable*) _tmp8_, _tmp10_);
#line 123 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp10_);
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp11_ = self->priv->undo_btn;
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-undo", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp12_);
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp13_ = _tmp12_;
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_button_set_image (_tmp11_, (GtkWidget*) _tmp13_);
#line 124 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp13_);
#line 127 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp14_ = self->header;
#line 127 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp15_ = self->priv->redo_btn;
#line 127 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_header_bar_pack_end (_tmp14_, (GtkWidget*) _tmp15_);
#line 128 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp16_ = self->header;
#line 128 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp17_ = self->priv->undo_btn;
#line 128 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_header_bar_pack_end (_tmp16_, (GtkWidget*) _tmp17_);
#line 999 "AppWindow.c"
}


void
app_window_build_header_bar (AppWindow* self)
{
#line 117 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 117 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->build_header_bar (self);
#line 1010 "AppWindow.c"
}


static void
_app_window_on_quit_gtk_action_callback (GtkAction* action,
                                         gpointer self)
{
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_quit ((AppWindow*) self);
#line 1020 "AppWindow.c"
}


static void
_app_window_on_fullscreen_gtk_action_callback (GtkAction* action,
                                               gpointer self)
{
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_fullscreen ((AppWindow*) self);
#line 1030 "AppWindow.c"
}


static void
_app_window_on_undo_gtk_action_callback (GtkAction* action,
                                         gpointer self)
{
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_undo ((AppWindow*) self);
#line 1040 "AppWindow.c"
}


static void
_app_window_on_redo_gtk_action_callback (GtkAction* action,
                                         gpointer self)
{
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_redo ((AppWindow*) self);
#line 1050 "AppWindow.c"
}


static void
_app_window_on_jump_to_file_gtk_action_callback (GtkAction* action,
                                                 gpointer self)
{
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_jump_to_file ((AppWindow*) self);
#line 1060 "AppWindow.c"
}


static void
_app_window_on_select_all_gtk_action_callback (GtkAction* action,
                                               gpointer self)
{
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_select_all ((AppWindow*) self);
#line 1070 "AppWindow.c"
}


static void
_app_window_on_select_none_gtk_action_callback (GtkAction* action,
                                                gpointer self)
{
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_select_none ((AppWindow*) self);
#line 1080 "AppWindow.c"
}


static void
_vala_array_add1 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1096 "AppWindow.c"
	}
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1100 "AppWindow.c"
}


static void
_vala_array_add2 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1116 "AppWindow.c"
	}
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1120 "AppWindow.c"
}


static void
_vala_array_add3 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1136 "AppWindow.c"
	}
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1140 "AppWindow.c"
}


static void
_vala_array_add4 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1156 "AppWindow.c"
	}
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1160 "AppWindow.c"
}


static void
_vala_array_add5 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1176 "AppWindow.c"
	}
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1180 "AppWindow.c"
}


static void
_vala_array_add6 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1196 "AppWindow.c"
	}
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1200 "AppWindow.c"
}


static void
_vala_array_add7 (GtkActionEntry* * array,
                  int* length,
                  int* size,
                  const GtkActionEntry* value)
{
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionEntry, *array, *size);
#line 1216 "AppWindow.c"
	}
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = *value;
#line 1220 "AppWindow.c"
}


static GtkActionEntry*
app_window_create_common_actions (AppWindow* self,
                                  int* result_length1)
{
	GtkActionEntry* result = NULL;
	GtkActionEntry quit = {0};
	GtkActionEntry _tmp0_ = {0};
	GtkActionEntry fullscreen = {0};
	GtkActionEntry _tmp1_ = {0};
	GtkActionEntry undo = {0};
	GtkActionEntry _tmp2_ = {0};
	GtkActionEntry redo = {0};
	GtkActionEntry _tmp3_ = {0};
	GtkActionEntry jump_to_file = {0};
	GtkActionEntry _tmp4_ = {0};
	GtkActionEntry select_all = {0};
	GtkActionEntry _tmp5_ = {0};
	GtkActionEntry select_none = {0};
	GtkActionEntry _tmp6_ = {0};
	GtkActionEntry* actions = NULL;
	GtkActionEntry* _tmp7_;
	gint actions_length1;
	gint _actions_size_;
	GtkActionEntry* _tmp8_;
	gint _tmp8__length1;
	GtkActionEntry _tmp9_;
	GtkActionEntry* _tmp10_;
	gint _tmp10__length1;
	GtkActionEntry _tmp11_;
	GtkActionEntry* _tmp12_;
	gint _tmp12__length1;
	GtkActionEntry _tmp13_;
	GtkActionEntry* _tmp14_;
	gint _tmp14__length1;
	GtkActionEntry _tmp15_;
	GtkActionEntry* _tmp16_;
	gint _tmp16__length1;
	GtkActionEntry _tmp17_;
	GtkActionEntry* _tmp18_;
	gint _tmp18__length1;
	GtkActionEntry _tmp19_;
	GtkActionEntry* _tmp20_;
	gint _tmp20__length1;
	GtkActionEntry _tmp21_;
	GtkActionEntry* _tmp22_;
	gint _tmp22__length1;
#line 132 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.name = "CommonQuit";
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.stock_id = NULL;
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.label = _ ("_Quit");
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.accelerator = "<Ctrl>Q";
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.tooltip = _ ("_Quit");
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_.callback = (GCallback) _app_window_on_quit_gtk_action_callback;
#line 133 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	quit = _tmp0_;
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.name = "CommonFullscreen";
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.stock_id = NULL;
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.label = _ ("Fulls_creen");
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.accelerator = "F11";
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.tooltip = _ ("Fulls_creen");
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_.callback = (GCallback) _app_window_on_fullscreen_gtk_action_callback;
#line 134 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	fullscreen = _tmp1_;
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.name = "CommonUndo";
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.stock_id = NULL;
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.label = NULL;
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.accelerator = "<Ctrl>Z";
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.tooltip = NULL;
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_.callback = (GCallback) _app_window_on_undo_gtk_action_callback;
#line 135 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	undo = _tmp2_;
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.name = "CommonRedo";
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.stock_id = NULL;
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.label = NULL;
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.accelerator = "<Ctrl><Shift>Z";
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.tooltip = NULL;
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_.callback = (GCallback) _app_window_on_redo_gtk_action_callback;
#line 136 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	redo = _tmp3_;
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.name = "CommonJumpToFile";
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.stock_id = NULL;
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.label = RESOURCES_JUMP_TO_FILE_MENU;
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.accelerator = "<Ctrl><Shift>M";
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.tooltip = RESOURCES_JUMP_TO_FILE_MENU;
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_.callback = (GCallback) _app_window_on_jump_to_file_gtk_action_callback;
#line 137 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	jump_to_file = _tmp4_;
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.name = "CommonSelectAll";
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.stock_id = NULL;
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.label = RESOURCES_SELECT_ALL_MENU;
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.accelerator = "<Ctrl>A";
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.tooltip = RESOURCES_SELECT_ALL_MENU;
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_.callback = (GCallback) _app_window_on_select_all_gtk_action_callback;
#line 138 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	select_all = _tmp5_;
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.name = "CommonSelectNone";
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.stock_id = NULL;
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.label = NULL;
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.accelerator = "<Ctrl><Shift>A";
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.tooltip = TRANSLATABLE;
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_.callback = (GCallback) _app_window_on_select_none_gtk_action_callback;
#line 139 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	select_none = _tmp6_;
#line 141 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = g_new0 (GtkActionEntry, 0);
#line 141 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	actions = _tmp7_;
#line 141 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	actions_length1 = 0;
#line 141 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_actions_size_ = actions_length1;
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = actions;
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8__length1 = actions_length1;
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = quit;
#line 142 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add1 (&actions, &actions_length1, &_actions_size_, &_tmp9_);
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = actions;
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10__length1 = actions_length1;
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp11_ = fullscreen;
#line 143 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add2 (&actions, &actions_length1, &_actions_size_, &_tmp11_);
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp12_ = actions;
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp12__length1 = actions_length1;
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp13_ = undo;
#line 144 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add3 (&actions, &actions_length1, &_actions_size_, &_tmp13_);
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp14_ = actions;
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp14__length1 = actions_length1;
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp15_ = redo;
#line 145 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add4 (&actions, &actions_length1, &_actions_size_, &_tmp15_);
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp16_ = actions;
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp16__length1 = actions_length1;
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp17_ = jump_to_file;
#line 146 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add5 (&actions, &actions_length1, &_actions_size_, &_tmp17_);
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp18_ = actions;
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp18__length1 = actions_length1;
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp19_ = select_all;
#line 147 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add6 (&actions, &actions_length1, &_actions_size_, &_tmp19_);
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp20_ = actions;
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp20__length1 = actions_length1;
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp21_ = select_none;
#line 148 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add7 (&actions, &actions_length1, &_actions_size_, &_tmp21_);
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp22_ = actions;
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp22__length1 = actions_length1;
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (result_length1) {
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*result_length1 = _tmp22__length1;
#line 1442 "AppWindow.c"
	}
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp22_;
#line 150 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1448 "AppWindow.c"
}


static void
app_window_real_on_fullscreen (AppWindow* self)
{
#line 153 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_on_fullscreen'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 153 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return;
#line 1459 "AppWindow.c"
}


void
app_window_on_fullscreen (AppWindow* self)
{
#line 153 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 153 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->on_fullscreen (self);
#line 1470 "AppWindow.c"
}


gboolean
app_window_has_instance (void)
{
	gboolean result = FALSE;
	AppWindow* _tmp0_;
#line 156 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 156 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp0_ != NULL;
#line 156 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1485 "AppWindow.c"
}


AppWindow*
app_window_get_instance (void)
{
	AppWindow* result = NULL;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
#line 160 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_instance;
#line 160 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp1_;
#line 160 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1503 "AppWindow.c"
}


FullscreenWindow*
app_window_get_fullscreen (void)
{
	FullscreenWindow* result = NULL;
	FullscreenWindow* _tmp0_;
	FullscreenWindow* _tmp1_;
#line 164 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 164 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp1_;
#line 164 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1521 "AppWindow.c"
}


GtkBuilder*
app_window_create_builder (void)
{
	GtkBuilder* result = NULL;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	GError * _inner_error_ = NULL;
#line 168 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = gtk_builder_new ();
#line 168 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	builder = _tmp0_;
#line 1536 "AppWindow.c"
	{
#line 170 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_builder_add_from_resource (builder, "/io/elementary/photos/shotwell.ui", &_inner_error_);
#line 170 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1542 "AppWindow.c"
			goto __catch9_g_error;
		}
#line 171 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_builder_connect_signals (builder, NULL);
#line 1547 "AppWindow.c"
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_error_ = _inner_error_;
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_inner_error_ = NULL;
#line 173 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _error_;
#line 173 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 173 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_warning ("AppWindow.vala:173: Unable to create Gtk.Builder: %s\n", _tmp2_);
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_error_free0 (_error_);
#line 1567 "AppWindow.c"
	}
	__finally9:
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (builder);
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_clear_error (&_inner_error_);
#line 169 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return NULL;
#line 1580 "AppWindow.c"
	}
#line 176 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = builder;
#line 176 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1586 "AppWindow.c"
}


void
app_window_error_message (const gchar* message,
                          GtkWindow* parent)
{
#line 179 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (message != NULL);
#line 180 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_error_message_with_title (_ (RESOURCES_APP_TITLE), message, parent, TRUE);
#line 1598 "AppWindow.c"
}


void
app_window_error_message_with_title (const gchar* title,
                                     const gchar* message,
                                     GtkWindow* parent,
                                     gboolean should_escape)
{
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 183 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (title != NULL);
#line 183 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (message != NULL);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 1622 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 1630 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 1639 "AppWindow.c"
	}
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = build_alert_body_text (title, message, should_escape);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp4_);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp4_);
#line 187 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp6_;
#line 191 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = build_alert_body_text (title, message, should_escape);
#line 191 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 191 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (dialog, _tmp8_);
#line 191 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp8_);
#line 193 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_set (dialog, "use-markup", TRUE, NULL);
#line 194 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 195 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 183 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 183 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 1673 "AppWindow.c"
}


gboolean
app_window_negate_affirm_question (const gchar* message,
                                   const gchar* negative,
                                   const gchar* affirmative,
                                   const gchar* title,
                                   GtkWindow* parent)
{
	gboolean result = FALSE;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean response = FALSE;
#line 198 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 198 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (negative != NULL, FALSE);
#line 198 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, FALSE);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 1702 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 1710 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 1719 "AppWindow.c"
	}
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = build_alert_body_text (title, message, TRUE);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _tmp4_);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp4_);
#line 200 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp6_;
#line 203 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = build_alert_body_text (title, message, TRUE);
#line 203 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 203 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (dialog, _tmp8_);
#line 203 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp8_);
#line 204 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) dialog, negative, GTK_RESPONSE_NO, affirmative, GTK_RESPONSE_YES, NULL);
#line 205 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_urgency_hint ((GtkWindow*) dialog, TRUE);
#line 207 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) dialog) == ((gint) GTK_RESPONSE_YES);
#line 209 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 211 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = response;
#line 211 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 211 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 211 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1759 "AppWindow.c"
}


GtkResponseType
app_window_negate_affirm_cancel_question (const gchar* message,
                                          const gchar* negative,
                                          const gchar* affirmative,
                                          const gchar* title,
                                          GtkWindow* parent)
{
	GtkResponseType result = 0;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint response = 0;
#line 214 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 214 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (negative != NULL, 0);
#line 214 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 1788 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 1796 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 1805 "AppWindow.c"
	}
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = build_alert_body_text (title, message, TRUE);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _tmp4_);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp4_);
#line 216 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp6_;
#line 219 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) dialog, negative, GTK_RESPONSE_NO, affirmative, GTK_RESPONSE_YES, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
#line 223 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = build_alert_body_text (title, message, TRUE);
#line 223 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 223 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (dialog, _tmp8_);
#line 223 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp8_);
#line 224 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_set (dialog, "use-markup", TRUE, NULL);
#line 226 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) dialog);
#line 228 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 230 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 230 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 230 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 230 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1845 "AppWindow.c"
}


GtkResponseType
app_window_affirm_cancel_negate_question (const gchar* message,
                                          const gchar* affirmative,
                                          const gchar* negative,
                                          const gchar* title,
                                          GtkWindow* parent)
{
	GtkResponseType result = 0;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint response = 0;
#line 233 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 233 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 233 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (negative != NULL, 0);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 1874 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 1882 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 1891 "AppWindow.c"
	}
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = build_alert_body_text (title, message, TRUE);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _tmp4_);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp4_);
#line 236 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp6_;
#line 239 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) dialog, affirmative, GTK_RESPONSE_YES, _ ("_Cancel"), GTK_RESPONSE_CANCEL, negative, GTK_RESPONSE_NO, NULL);
#line 244 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = build_alert_body_text (title, message, TRUE);
#line 244 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 244 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (dialog, _tmp8_);
#line 244 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp8_);
#line 245 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_set (dialog, "use-markup", TRUE, NULL);
#line 247 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) dialog);
#line 249 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 251 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 251 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 251 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 251 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 1931 "AppWindow.c"
}


GtkResponseType
app_window_affirm_cancel_question (const gchar* message,
                                   const gchar* affirmative,
                                   const gchar* title,
                                   GtkWindow* parent)
{
	GtkResponseType result = 0;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GtkMessageDialog* _tmp7_;
	GtkMessageDialog* _tmp8_;
	gint response = 0;
	GtkMessageDialog* _tmp9_;
	GtkMessageDialog* _tmp10_;
#line 254 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 254 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 1959 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 1967 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 1976 "AppWindow.c"
	}
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", message);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 256 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp3_;
#line 259 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = dialog;
#line 259 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (_tmp4_, message);
#line 260 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = dialog;
#line 260 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_set (_tmp5_, "use-markup", TRUE, NULL);
#line 261 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (title != NULL) {
#line 261 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = title;
#line 1996 "AppWindow.c"
	} else {
#line 261 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = _ (RESOURCES_APP_TITLE);
#line 2000 "AppWindow.c"
	}
#line 261 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = dialog;
#line 261 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) _tmp7_, _tmp6_);
#line 262 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = dialog;
#line 262 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp8_, affirmative, GTK_RESPONSE_YES, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
#line 265 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = dialog;
#line 265 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp9_);
#line 267 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = dialog;
#line 267 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp10_);
#line 269 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 269 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 269 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 269 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2026 "AppWindow.c"
}


GtkResponseType
app_window_cancel_affirm_question (const gchar* message,
                                   const gchar* affirmative,
                                   const gchar* title,
                                   GtkWindow* parent)
{
	GtkResponseType result = 0;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GtkMessageDialog* _tmp7_;
	GtkMessageDialog* _tmp8_;
	gint response = 0;
	GtkMessageDialog* _tmp9_;
	GtkMessageDialog* _tmp10_;
#line 272 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 272 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 2054 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 2062 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 2071 "AppWindow.c"
	}
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", message);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 274 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp3_;
#line 277 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = dialog;
#line 277 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_message_dialog_set_markup (_tmp4_, message);
#line 278 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = dialog;
#line 278 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_set (_tmp5_, "use-markup", TRUE, NULL);
#line 279 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (title != NULL) {
#line 279 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = title;
#line 2091 "AppWindow.c"
	} else {
#line 279 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = _ (RESOURCES_APP_TITLE);
#line 2095 "AppWindow.c"
	}
#line 279 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = dialog;
#line 279 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) _tmp7_, _tmp6_);
#line 280 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = dialog;
#line 280 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp8_, _ ("_Cancel"), GTK_RESPONSE_CANCEL, affirmative, GTK_RESPONSE_YES, NULL);
#line 283 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = dialog;
#line 283 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp9_);
#line 285 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = dialog;
#line 285 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp10_);
#line 287 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 287 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 287 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 287 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2121 "AppWindow.c"
}


GtkResponseType
app_window_negate_affirm_all_cancel_question (const gchar* message,
                                              const gchar* negative,
                                              const gchar* affirmative,
                                              const gchar* affirmative_all,
                                              const gchar* title,
                                              GtkWindow* parent)
{
	GtkResponseType result = 0;
	GtkWindow* _tmp0_ = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkMessageDialog* _tmp3_;
	const gchar* _tmp4_ = NULL;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	gint response = 0;
	GtkMessageDialog* _tmp7_;
	GtkMessageDialog* _tmp8_;
#line 290 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (message != NULL, 0);
#line 290 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (negative != NULL, 0);
#line 290 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative != NULL, 0);
#line 290 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (affirmative_all != NULL, 0);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (parent != NULL) {
#line 2153 "AppWindow.c"
		GtkWindow* _tmp1_;
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _g_object_ref0 (parent);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _tmp1_;
#line 2161 "AppWindow.c"
	} else {
		AppWindow* _tmp2_;
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = app_window_get_instance ();
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = (GtkWindow*) _tmp2_;
#line 2170 "AppWindow.c"
	}
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", message);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 293 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	dialog = _tmp3_;
#line 295 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (title != NULL) {
#line 295 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = title;
#line 2182 "AppWindow.c"
	} else {
#line 295 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = _ (RESOURCES_APP_TITLE);
#line 2186 "AppWindow.c"
	}
#line 295 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = dialog;
#line 295 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_set_title ((GtkWindow*) _tmp5_, _tmp4_);
#line 296 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = dialog;
#line 296 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp6_, negative, GTK_RESPONSE_NO, affirmative, GTK_RESPONSE_YES, affirmative_all, GTK_RESPONSE_APPLY, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
#line 299 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = dialog;
#line 299 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp7_);
#line 301 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = dialog;
#line 301 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp8_);
#line 303 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = (GtkResponseType) response;
#line 303 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (dialog);
#line 303 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp0_);
#line 303 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2212 "AppWindow.c"
}


void
app_window_database_error (GError* err)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 307 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = err->message;
#line 307 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = g_strdup_printf (_ ("A fatal error occurred when accessing Photos' library.  Photos cannot " \
"continue.\n" \
"\n" \
"%s"), _tmp0_);
#line 307 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 307 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_panic (_tmp2_);
#line 307 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_free0 (_tmp2_);
#line 2232 "AppWindow.c"
}


void
app_window_panic (const gchar* msg)
{
	Application* _tmp0_;
	Application* _tmp1_;
#line 311 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (msg != NULL);
#line 312 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_critical ("AppWindow.vala:312: %s", msg);
#line 313 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_error_message (msg, NULL);
#line 315 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = application_get_instance ();
#line 315 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 315 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	application_panic (_tmp1_);
#line 315 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 2255 "AppWindow.c"
}


static gchar*
app_window_real_get_app_role (AppWindow* self)
{
#line 318 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_critical ("Type `%s' does not implement abstract method `app_window_get_app_role'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 318 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return NULL;
#line 2266 "AppWindow.c"
}


gchar*
app_window_get_app_role (AppWindow* self)
{
#line 318 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 318 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return APP_WINDOW_GET_CLASS (self)->get_app_role (self);
#line 2277 "AppWindow.c"
}


static void
app_window_real_on_quit (AppWindow* self)
{
	Application* _tmp0_;
	Application* _tmp1_;
#line 321 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = application_get_instance ();
#line 321 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 321 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	application_exit (_tmp1_);
#line 321 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 2294 "AppWindow.c"
}


void
app_window_on_quit (AppWindow* self)
{
#line 320 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 320 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->on_quit (self);
#line 2305 "AppWindow.c"
}


void
app_window_on_jump_to_file (AppWindow* self)
{
	Page* _tmp0_;
	Page* _tmp1_;
	ViewCollection* _tmp2_;
	ViewCollection* _tmp3_;
	gboolean _tmp4_;
	MediaSource* media = NULL;
	Page* _tmp5_;
	Page* _tmp6_;
	ViewCollection* _tmp7_;
	ViewCollection* _tmp8_;
	DataView* _tmp9_;
	DataView* _tmp10_;
	DataSource* _tmp11_;
	MediaSource* _tmp12_;
	MediaSource* _tmp13_;
	MediaSource* _tmp14_;
	GError * _inner_error_ = NULL;
#line 324 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = page_get_view (_tmp1_);
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = _tmp2_;
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = view_collection_get_selected_count (_tmp3_) != 1;
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_data_collection_unref0 (_tmp3_);
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 325 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp4_) {
#line 326 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2349 "AppWindow.c"
	}
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = page_get_view (_tmp6_);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = _tmp7_;
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = view_collection_get_selected_at (_tmp8_, 0);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = _tmp9_;
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp11_ = data_view_get_source (_tmp10_);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp12_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_MEDIA_SOURCE) ? ((MediaSource*) _tmp11_) : NULL;
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp12_ == NULL) {
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp11_);
#line 2371 "AppWindow.c"
	}
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp13_ = _tmp12_;
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp10_);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_data_collection_unref0 (_tmp8_);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 328 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	media = _tmp13_;
#line 330 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp14_ = media;
#line 330 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp14_ == NULL) {
#line 331 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (media);
#line 331 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2391 "AppWindow.c"
	}
	{
		AppWindow* _tmp15_;
		AppWindow* _tmp16_;
		MediaSource* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp15_ = app_window_get_instance ();
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp16_ = _tmp15_;
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp17_ = media;
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp18_ = media_source_get_master_file (_tmp17_);
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp19_ = _tmp18_;
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		app_window_show_file_uri (_tmp16_, _tmp19_, &_inner_error_);
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp19_);
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp16_);
#line 334 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2417 "AppWindow.c"
			goto __catch10_g_error;
		}
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* err = NULL;
		GError* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		err = _inner_error_;
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_inner_error_ = NULL;
#line 336 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp20_ = err;
#line 336 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp21_ = resources_jump_to_file_failed (_tmp20_);
#line 336 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp22_ = _tmp21_;
#line 336 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		app_window_error_message (_tmp22_, NULL);
#line 336 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_free0 (_tmp22_);
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_error_free0 (err);
#line 2444 "AppWindow.c"
	}
	__finally10:
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (media);
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_clear_error (&_inner_error_);
#line 333 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2457 "AppWindow.c"
	}
#line 324 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (media);
#line 2461 "AppWindow.c"
}


static void
app_window_real_destroy (GtkWidget* base)
{
	AppWindow * self;
#line 340 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = (AppWindow*) base;
#line 341 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_quit (self);
#line 2473 "AppWindow.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2482 "AppWindow.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2491 "AppWindow.c"
}


void
app_window_show_file_uri (AppWindow* self,
                          GFile* file,
                          GError** error)
{
	GAppInfo* app_info = NULL;
	GAppInfo* _tmp0_;
	GList* file_list = NULL;
	GFile* _tmp1_;
	GdkWindow* _tmp2_;
	GdkScreen* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkAppLaunchContext* _tmp5_;
	GdkAppLaunchContext* _tmp6_;
	GError * _inner_error_ = NULL;
#line 344 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 344 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (file != NULL);
#line 345 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = g_app_info_get_default_for_type ("inode/directory", TRUE);
#line 345 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_info = _tmp0_;
#line 346 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	file_list = NULL;
#line 347 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 347 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	file_list = g_list_append (file_list, _tmp1_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = gtk_widget_get_window ((GtkWidget*) self);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = gdk_window_get_screen (_tmp2_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = gdk_screen_get_display (_tmp3_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = gdk_display_get_app_launch_context (_tmp4_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_app_info_launch (app_info, file_list, (GAppLaunchContext*) _tmp6_, &_inner_error_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_propagate_error (error, _inner_error_);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (app_info);
#line 348 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2548 "AppWindow.c"
	}
#line 344 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 344 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (app_info);
#line 2554 "AppWindow.c"
}


void
app_window_show_uri (AppWindow* self,
                     const gchar* url,
                     GError** error)
{
	GdkWindow* _tmp0_;
	GdkScreen* _tmp1_;
	GError * _inner_error_ = NULL;
#line 351 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 351 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (url != NULL);
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = gdk_window_get_screen (_tmp0_);
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	sys_show_uri (_tmp1_, url, &_inner_error_);
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_propagate_error (error, _inner_error_);
#line 352 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2582 "AppWindow.c"
	}
}


static void
_vala_array_add8 (GtkActionGroup** * array,
                  int* length,
                  int* size,
                  GtkActionGroup* value)
{
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if ((*length) == (*size)) {
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*array = g_renew (GtkActionGroup*, *array, (*size) + 1);
#line 2599 "AppWindow.c"
	}
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[(*length)++] = value;
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	(*array)[*length] = NULL;
#line 2605 "AppWindow.c"
}


static GtkActionGroup**
app_window_real_create_common_action_groups (AppWindow* self,
                                             int* result_length1)
{
	GtkActionGroup** result = NULL;
	GtkActionGroup** groups = NULL;
	GtkActionGroup** _tmp0_;
	gint groups_length1;
	gint _groups_size_;
	GtkActionGroup* _tmp1_;
	gint _tmp2_;
	GtkActionEntry* _tmp3_;
	GtkActionEntry* _tmp4_;
	gint _tmp4__length1;
	GtkActionGroup** _tmp5_;
	gint _tmp5__length1;
	GtkActionGroup* _tmp6_;
	GtkActionGroup* _tmp7_;
	GtkActionGroup** _tmp8_;
	gint _tmp8__length1;
#line 356 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = g_new0 (GtkActionGroup*, 0 + 1);
#line 356 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	groups = _tmp0_;
#line 356 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	groups_length1 = 0;
#line 356 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_groups_size_ = groups_length1;
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = self->priv->common_action_group;
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = app_window_create_common_actions (self, &_tmp2_);
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4__length1 = _tmp2_;
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_action_group_add_actions (_tmp1_, _tmp4_, (guint) _tmp2_, self);
#line 358 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = (g_free (_tmp4_), NULL);
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = groups;
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5__length1 = groups_length1;
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = self->priv->common_action_group;
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 359 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_vala_array_add8 (&groups, &groups_length1, &_groups_size_, _tmp7_);
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8_ = groups;
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp8__length1 = groups_length1;
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (result_length1) {
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*result_length1 = _tmp8__length1;
#line 2667 "AppWindow.c"
	}
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp8_;
#line 361 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2673 "AppWindow.c"
}


GtkActionGroup**
app_window_create_common_action_groups (AppWindow* self,
                                        int* result_length1)
{
#line 355 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 355 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return APP_WINDOW_GET_CLASS (self)->create_common_action_groups (self, result_length1);
#line 2685 "AppWindow.c"
}


static GtkActionGroup**
_vala_array_dup1 (GtkActionGroup** self,
                  int length)
{
	GtkActionGroup** result;
	int i;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = g_new0 (GtkActionGroup*, length + 1);
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	for (i = 0; i < length; i++) {
#line 2699 "AppWindow.c"
		GtkActionGroup* _tmp0_;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = _g_object_ref0 (self[i]);
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		result[i] = _tmp0_;
#line 2705 "AppWindow.c"
	}
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2709 "AppWindow.c"
}


GtkActionGroup**
app_window_get_common_action_groups (AppWindow* self,
                                     int* result_length1)
{
	GtkActionGroup** result = NULL;
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
	GtkActionGroup** _tmp1_;
	gint _tmp1__length1;
	GtkActionGroup** _tmp2_;
	gint _tmp2__length1;
#line 364 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1__length1 = _tmp0__length1;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2__length1 = _tmp1__length1;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (result_length1) {
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		*result_length1 = _tmp2__length1;
#line 2742 "AppWindow.c"
	}
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp2_;
#line 365 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2748 "AppWindow.c"
}


void
app_window_go_fullscreen (AppWindow* self,
                          Page* page)
{
	FullscreenWindow* _tmp0_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	FullscreenWindow* fsw = NULL;
	FullscreenWindow* _tmp4_;
	Page* _tmp5_;
	Page* _tmp6_;
	gboolean _tmp7_;
	FullscreenWindow* _tmp11_;
	FullscreenWindow* _tmp12_;
	FullscreenWindow* _tmp13_;
#line 368 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 368 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 370 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 370 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp0_ != NULL) {
#line 2775 "AppWindow.c"
		FullscreenWindow* _tmp1_;
#line 371 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = app_window_fullscreen_window;
#line 371 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_window_present ((GtkWindow*) _tmp1_);
#line 373 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2783 "AppWindow.c"
	}
#line 376 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 376 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->pos_x = _tmp2_;
#line 376 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->pos_y = _tmp3_;
#line 377 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 379 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = fullscreen_window_new (page);
#line 379 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 379 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	fsw = _tmp4_;
#line 381 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = page_window_get_current_page ((PageWindow*) self);
#line 381 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp6_ = _tmp5_;
#line 381 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp7_ = _tmp6_ != NULL;
#line 381 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp6_);
#line 381 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp7_) {
#line 2809 "AppWindow.c"
		Page* _tmp8_;
		Page* _tmp9_;
		FullscreenWindow* _tmp10_;
#line 382 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp8_ = page_window_get_current_page ((PageWindow*) self);
#line 382 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp9_ = _tmp8_;
#line 382 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp10_ = fsw;
#line 382 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		page_switching_to_fullscreen (_tmp9_, _tmp10_);
#line 382 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp9_);
#line 2823 "AppWindow.c"
	}
#line 384 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp11_ = fsw;
#line 384 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 384 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 384 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_fullscreen_window = _tmp12_;
#line 385 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp13_ = app_window_fullscreen_window;
#line 385 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) _tmp13_);
#line 368 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (fsw);
#line 2839 "AppWindow.c"
}


void
app_window_end_fullscreen (AppWindow* self)
{
	FullscreenWindow* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	Page* _tmp4_;
	gboolean _tmp5_;
	FullscreenWindow* _tmp9_;
	FullscreenWindow* _tmp10_;
#line 388 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 389 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_fullscreen_window;
#line 389 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp0_ == NULL) {
#line 390 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 2862 "AppWindow.c"
	}
#line 392 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = self->pos_x;
#line 392 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = self->pos_y;
#line 392 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_move ((GtkWindow*) self, _tmp1_, _tmp2_);
#line 394 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 396 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = page_window_get_current_page ((PageWindow*) self);
#line 396 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 396 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp5_ = _tmp4_ != NULL;
#line 396 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 396 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp5_) {
#line 2882 "AppWindow.c"
		Page* _tmp6_;
		Page* _tmp7_;
		FullscreenWindow* _tmp8_;
#line 397 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = page_window_get_current_page ((PageWindow*) self);
#line 397 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp7_ = _tmp6_;
#line 397 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp8_ = app_window_fullscreen_window;
#line 397 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		page_returning_from_fullscreen (_tmp7_, _tmp8_);
#line 397 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp7_);
#line 2896 "AppWindow.c"
	}
#line 399 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp9_ = app_window_fullscreen_window;
#line 399 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_hide ((GtkWidget*) _tmp9_);
#line 400 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp10_ = app_window_fullscreen_window;
#line 400 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp10_);
#line 401 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (app_window_fullscreen_window);
#line 401 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_fullscreen_window = NULL;
#line 403 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	gtk_window_present ((GtkWindow*) self);
#line 2912 "AppWindow.c"
}


GtkAction*
app_window_get_common_action (AppWindow* self,
                              const gchar* name)
{
	GtkAction* result = NULL;
	GtkActionGroup** _tmp0_;
	gint _tmp0__length1;
#line 406 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 406 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = self->common_action_groups;
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0__length1 = self->common_action_groups_length1;
#line 2931 "AppWindow.c"
	{
		GtkActionGroup** group_collection = NULL;
		gint group_collection_length1 = 0;
		gint _group_collection_size_ = 0;
		gint group_it = 0;
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		group_collection = _tmp0_;
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		group_collection_length1 = _tmp0__length1;
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		for (group_it = 0; group_it < _tmp0__length1; group_it = group_it + 1) {
#line 2943 "AppWindow.c"
			GtkActionGroup* _tmp1_;
			GtkActionGroup* group = NULL;
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
			_tmp1_ = _g_object_ref0 (group_collection[group_it]);
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
			group = _tmp1_;
#line 2950 "AppWindow.c"
			{
				GtkAction* action = NULL;
				GtkActionGroup* _tmp2_;
				GtkAction* _tmp3_;
				GtkAction* _tmp4_;
				GtkAction* _tmp5_;
#line 408 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp2_ = group;
#line 408 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp3_ = gtk_action_group_get_action (_tmp2_, name);
#line 408 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp4_ = _g_object_ref0 (_tmp3_);
#line 408 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				action = _tmp4_;
#line 409 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_tmp5_ = action;
#line 409 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				if (_tmp5_ != NULL) {
#line 410 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
					result = action;
#line 410 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
					_g_object_unref0 (group);
#line 410 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
					return result;
#line 2975 "AppWindow.c"
				}
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_g_object_unref0 (action);
#line 407 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
				_g_object_unref0 (group);
#line 2981 "AppWindow.c"
			}
		}
	}
#line 413 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_warning ("AppWindow.vala:413: No common action found: %s", name);
#line 415 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = NULL;
#line 415 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 2991 "AppWindow.c"
}


void
app_window_set_common_action_sensitive (AppWindow* self,
                                        const gchar* name,
                                        gboolean sensitive)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 418 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 418 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 419 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 419 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	action = _tmp0_;
#line 420 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = action;
#line 420 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 3015 "AppWindow.c"
		GtkAction* _tmp2_;
#line 421 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = action;
#line 421 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_action_set_sensitive (_tmp2_, sensitive);
#line 3021 "AppWindow.c"
	}
#line 418 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (action);
#line 3025 "AppWindow.c"
}


void
app_window_set_common_action_visible (AppWindow* self,
                                      const gchar* name,
                                      gboolean visible)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 424 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 424 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 425 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 425 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	action = _tmp0_;
#line 426 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = action;
#line 426 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 3049 "AppWindow.c"
		GtkAction* _tmp2_;
#line 427 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = action;
#line 427 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_action_set_visible (_tmp2_, visible);
#line 3055 "AppWindow.c"
	}
#line 424 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (action);
#line 3059 "AppWindow.c"
}


static void
_app_window_on_update_common_actions_data_collection_contents_altered (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       GeeIterable* removed,
                                                                       gpointer self)
{
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 3071 "AppWindow.c"
}


static void
_app_window_on_update_common_actions_view_collection_selection_group_altered (ViewCollection* _sender,
                                                                              gpointer self)
{
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 3081 "AppWindow.c"
}


static void
_app_window_on_update_common_actions_view_collection_items_state_changed (ViewCollection* _sender,
                                                                          GeeIterable* changed,
                                                                          gpointer self)
{
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_on_update_common_actions ((AppWindow*) self);
#line 3092 "AppWindow.c"
}


static void
app_window_real_switched_pages (PageWindow* base,
                                Page* old_page,
                                Page* new_page)
{
	AppWindow * self;
#line 430 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = (AppWindow*) base;
#line 431 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_update_common_action_availability (self, old_page, new_page);
#line 433 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (old_page != NULL) {
#line 3108 "AppWindow.c"
		ViewCollection* _tmp0_;
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		ViewCollection* _tmp4_;
		guint _tmp5_;
		ViewCollection* _tmp6_;
		ViewCollection* _tmp7_;
		guint _tmp8_;
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp0_ = page_get_view (old_page);
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp1_ = _tmp0_;
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_handlers_disconnect_matched ((DataCollection*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self);
#line 434 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp1_);
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp3_ = page_get_view (old_page);
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = _tmp3_;
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_parse_name ("selection-group-altered", TYPE_VIEW_COLLECTION, &_tmp5_, NULL, FALSE);
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self);
#line 435 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp4_);
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = page_get_view (old_page);
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp7_ = _tmp6_;
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_parse_name ("items-state-changed", TYPE_VIEW_COLLECTION, &_tmp8_, NULL, FALSE);
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self);
#line 436 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp7_);
#line 3148 "AppWindow.c"
	}
#line 439 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (new_page != NULL) {
#line 3152 "AppWindow.c"
		ViewCollection* _tmp9_;
		ViewCollection* _tmp10_;
		ViewCollection* _tmp11_;
		ViewCollection* _tmp12_;
		ViewCollection* _tmp13_;
		ViewCollection* _tmp14_;
		ViewCollection* _tmp15_;
		ViewCollection* _tmp16_;
		ViewCollection* _tmp17_;
		ViewCollection* _tmp18_;
#line 440 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp9_ = page_get_view (new_page);
#line 440 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp10_ = _tmp9_;
#line 440 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_connect_object ((DataCollection*) _tmp10_, "contents-altered", (GCallback) _app_window_on_update_common_actions_data_collection_contents_altered, self, 0);
#line 440 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp10_);
#line 441 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp11_ = page_get_view (new_page);
#line 441 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp12_ = _tmp11_;
#line 441 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_connect_object (_tmp12_, "selection-group-altered", (GCallback) _app_window_on_update_common_actions_view_collection_selection_group_altered, self, 0);
#line 441 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp12_);
#line 442 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp13_ = page_get_view (new_page);
#line 442 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp14_ = _tmp13_;
#line 442 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		g_signal_connect_object (_tmp14_, "items-state-changed", (GCallback) _app_window_on_update_common_actions_view_collection_items_state_changed, self, 0);
#line 442 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp14_);
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp15_ = page_get_view (new_page);
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp16_ = _tmp15_;
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp17_ = page_get_view (new_page);
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp18_ = _tmp17_;
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		app_window_update_common_actions (self, new_page, view_collection_get_selected_count (_tmp16_), data_collection_get_count ((DataCollection*) _tmp18_));
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp18_);
#line 444 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp16_);
#line 3201 "AppWindow.c"
	}
#line 448 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	PAGE_WINDOW_CLASS (app_window_parent_class)->switched_pages (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), old_page, new_page);
#line 3205 "AppWindow.c"
}


static void
app_window_real_update_common_action_availability (AppWindow* self,
                                                   Page* old_page,
                                                   Page* new_page)
{
	gboolean is_checkerboard = FALSE;
#line 455 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	is_checkerboard = G_TYPE_CHECK_INSTANCE_TYPE (new_page, TYPE_CHECKERBOARD_PAGE);
#line 457 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_set_common_action_sensitive (self, "CommonSelectAll", is_checkerboard);
#line 458 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_set_common_action_sensitive (self, "CommonSelectNone", is_checkerboard);
#line 3221 "AppWindow.c"
}


void
app_window_update_common_action_availability (AppWindow* self,
                                              Page* old_page,
                                              Page* new_page)
{
#line 454 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 454 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->update_common_action_availability (self, old_page, new_page);
#line 3234 "AppWindow.c"
}


static void
app_window_real_update_common_actions (AppWindow* self,
                                       Page* page,
                                       gint selected_count,
                                       gint count)
{
#line 464 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (page != NULL);
#line 465 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_CHECKERBOARD_PAGE)) {
#line 466 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		app_window_set_common_action_sensitive (self, "CommonSelectAll", count > 0);
#line 3250 "AppWindow.c"
	}
#line 467 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_set_common_action_sensitive (self, "CommonJumpToFile", selected_count == 1);
#line 469 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_undo_action (self);
#line 470 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_redo_action (self);
#line 3258 "AppWindow.c"
}


void
app_window_update_common_actions (AppWindow* self,
                                  Page* page,
                                  gint selected_count,
                                  gint count)
{
#line 464 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 464 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	APP_WINDOW_GET_CLASS (self)->update_common_actions (self, page, selected_count, count);
#line 3272 "AppWindow.c"
}


static void
app_window_on_update_common_actions (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	Page* _tmp1_;
#line 473 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 474 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 474 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	page = _tmp0_;
#line 475 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = page;
#line 475 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ != NULL) {
#line 3292 "AppWindow.c"
		Page* _tmp2_;
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
		Page* _tmp6_;
		ViewCollection* _tmp7_;
		ViewCollection* _tmp8_;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = page;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp3_ = page;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = page;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp7_ = page_get_view (_tmp6_);
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp8_ = _tmp7_;
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		app_window_update_common_actions (self, _tmp2_, view_collection_get_selected_count (_tmp5_), data_collection_get_count ((DataCollection*) _tmp8_));
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp8_);
#line 476 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 3320 "AppWindow.c"
	}
#line 473 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (page);
#line 3324 "AppWindow.c"
}


static gpointer
_command_manager_ref0 (gpointer self)
{
#line 480 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return self ? command_manager_ref (self) : NULL;
#line 3333 "AppWindow.c"
}


CommandManager*
app_window_get_command_manager (void)
{
	CommandManager* result = NULL;
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 480 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 480 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _command_manager_ref0 (_tmp0_);
#line 480 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = _tmp1_;
#line 480 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 3351 "AppWindow.c"
}


static void
app_window_on_command_manager_altered (AppWindow* self)
{
#line 483 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 484 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_undo_action (self);
#line 485 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_redo_action (self);
#line 3364 "AppWindow.c"
}


static void
app_window_decorate_command_manager_action (AppWindow* self,
                                            const gchar* name,
                                            GtkButton* button,
                                            const gchar* default_explanation,
                                            CommandDescription* desc)
{
	GtkAction* action = NULL;
	GtkAction* _tmp0_;
	GtkAction* _tmp1_;
#line 488 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 488 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (name != NULL);
#line 488 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (button != NULL);
#line 488 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (default_explanation != NULL);
#line 489 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_get_common_action (self, name);
#line 489 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	action = _tmp0_;
#line 490 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = action;
#line 490 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 491 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (action);
#line 491 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		return;
#line 3398 "AppWindow.c"
	}
#line 494 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (desc != NULL) {
#line 3402 "AppWindow.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GtkAction* _tmp6_;
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp2_ = command_description_get_name (desc);
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp3_ = _tmp2_;
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = g_strdup_printf ("%s %s", default_explanation, _tmp3_);
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, _tmp5_);
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_free0 (_tmp5_);
#line 495 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_free0 (_tmp3_);
#line 496 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp6_ = action;
#line 496 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_action_set_sensitive (_tmp6_, TRUE);
#line 3426 "AppWindow.c"
	} else {
		GtkAction* _tmp7_;
#line 498 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) button, default_explanation);
#line 499 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp7_ = action;
#line 499 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_action_set_sensitive (_tmp7_, FALSE);
#line 3435 "AppWindow.c"
	}
#line 488 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (action);
#line 3439 "AppWindow.c"
}


void
app_window_decorate_undo_action (AppWindow* self)
{
	GtkButton* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	CommandDescription* _tmp3_;
	CommandDescription* _tmp4_;
#line 503 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = self->priv->undo_btn;
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = app_window_get_command_manager ();
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = command_manager_get_undo_description (_tmp2_);
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, "CommonUndo", _tmp0_, _ ("Undo"), _tmp4_);
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 504 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_command_manager_unref0 (_tmp2_);
#line 3469 "AppWindow.c"
}


void
app_window_decorate_redo_action (AppWindow* self)
{
	GtkButton* _tmp0_;
	CommandManager* _tmp1_;
	CommandManager* _tmp2_;
	CommandDescription* _tmp3_;
	CommandDescription* _tmp4_;
#line 507 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = self->priv->redo_btn;
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = app_window_get_command_manager ();
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = _tmp1_;
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp3_ = command_manager_get_redo_description (_tmp2_);
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp4_ = _tmp3_;
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_decorate_command_manager_action (self, "CommonRedo", _tmp0_, _ ("Redo"), _tmp4_);
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (_tmp4_);
#line 508 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_command_manager_unref0 (_tmp2_);
#line 3499 "AppWindow.c"
}


static void
app_window_on_undo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 511 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 512 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 512 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	command_manager_undo (_tmp0_);
#line 3513 "AppWindow.c"
}


static void
app_window_on_redo (AppWindow* self)
{
	CommandManager* _tmp0_;
#line 515 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 516 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = app_window_command_manager;
#line 516 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	command_manager_redo (_tmp0_);
#line 3527 "AppWindow.c"
}


static void
app_window_on_select_all (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 519 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 520 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 520 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_CHECKERBOARD_PAGE) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 520 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 520 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 3548 "AppWindow.c"
	}
#line 520 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 521 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = page;
#line 521 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 3556 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 522 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp3_ = page;
#line 522 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 522 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 522 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		view_collection_select_all (_tmp5_);
#line 522 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 3570 "AppWindow.c"
	}
#line 519 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (page);
#line 3574 "AppWindow.c"
}


static void
app_window_on_select_none (AppWindow* self)
{
	Page* page = NULL;
	Page* _tmp0_;
	CheckerboardPage* _tmp1_;
	Page* _tmp2_;
#line 525 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_if_fail (self != NULL);
#line 526 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = page_window_get_current_page ((PageWindow*) self);
#line 526 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_CHECKERBOARD_PAGE) ? ((CheckerboardPage*) _tmp0_) : NULL;
#line 526 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp1_ == NULL) {
#line 526 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_g_object_unref0 (_tmp0_);
#line 3595 "AppWindow.c"
	}
#line 526 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	page = (Page*) _tmp1_;
#line 527 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp2_ = page;
#line 527 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (_tmp2_ != NULL) {
#line 3603 "AppWindow.c"
		Page* _tmp3_;
		ViewCollection* _tmp4_;
		ViewCollection* _tmp5_;
#line 528 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp3_ = page;
#line 528 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp4_ = page_get_view (_tmp3_);
#line 528 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_tmp5_ = _tmp4_;
#line 528 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		view_collection_unselect_all (_tmp5_);
#line 528 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		_data_collection_unref0 (_tmp5_);
#line 3617 "AppWindow.c"
	}
#line 525 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (page);
#line 3621 "AppWindow.c"
}


static gboolean
app_window_real_configure_event (GtkWidget* base,
                                 GdkEventConfigure* event)
{
	AppWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 531 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = (AppWindow*) base;
#line 531 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 532 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_object_get ((GtkWindow*) self, "is-maximized", &_tmp0_, NULL);
#line 532 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp1_ = _tmp0_;
#line 532 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	if (!_tmp1_) {
#line 3643 "AppWindow.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 533 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		gtk_window_get_size ((GtkWindow*) self, &_tmp2_, &_tmp3_);
#line 533 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.width = _tmp2_;
#line 533 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
		self->dimensions.height = _tmp3_;
#line 3652 "AppWindow.c"
	}
#line 535 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	result = GTK_WIDGET_CLASS (app_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PAGE_WINDOW, PageWindow), event);
#line 535 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return result;
#line 3658 "AppWindow.c"
}


static GObject *
app_window_constructor (GType type,
                        guint n_construct_properties,
                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AppWindow * self;
	GSettings* _tmp0_;
#line 49 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	parent_class = G_OBJECT_CLASS (app_window_parent_class);
#line 49 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = g_settings_new (GSETTINGS_CONFIGURATION_ENGINE_WINDOW_PREFS_SCHEMA_NAME);
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 50 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->window_settings = _tmp0_;
#line 49 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	return obj;
#line 3685 "AppWindow.c"
}


static void
app_window_class_init (AppWindowClass * klass)
{
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	app_window_parent_class = g_type_class_peek_parent (klass);
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	g_type_class_adjust_private_offset (klass, &AppWindow_private_offset);
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->set_default_title = (void (*) (AppWindow *)) app_window_real_set_default_title;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->build_header_bar = (void (*) (AppWindow *)) app_window_real_build_header_bar;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->on_fullscreen = (void (*) (AppWindow *)) app_window_real_on_fullscreen;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->get_app_role = (gchar* (*) (AppWindow *)) app_window_real_get_app_role;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->on_quit = (void (*) (AppWindow *)) app_window_real_on_quit;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget *)) app_window_real_destroy;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->create_common_action_groups = (GtkActionGroup** (*) (AppWindow *, int*)) app_window_real_create_common_action_groups;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((PageWindowClass *) klass)->switched_pages = (void (*) (PageWindow *, Page*, Page*)) app_window_real_switched_pages;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_action_availability = (void (*) (AppWindow *, Page*, Page*)) app_window_real_update_common_action_availability;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((AppWindowClass *) klass)->update_common_actions = (void (*) (AppWindow *, Page*, gint, gint)) app_window_real_update_common_actions;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget *, GdkEventConfigure*)) app_window_real_configure_event;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = app_window_constructor;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = app_window_finalize;
#line 3722 "AppWindow.c"
}


static void
app_window_instance_init (AppWindow * self)
{
	GtkActionGroup* _tmp0_;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->priv = app_window_get_instance_private (self);
#line 38 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->pos_x = 0;
#line 39 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->pos_y = 0;
#line 42 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_tmp0_ = gtk_action_group_new ("AppWindowGlobalActionGroup");
#line 42 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->priv->common_action_group = _tmp0_;
#line 3740 "AppWindow.c"
}


static void
app_window_finalize (GObject * obj)
{
	AppWindow * self;
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APP_WINDOW, AppWindow);
#line 36 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	self->common_action_groups = (_vala_array_free (self->common_action_groups, self->common_action_groups_length1, (GDestroyNotify) g_object_unref), NULL);
#line 40 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->header);
#line 42 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->priv->common_action_group);
#line 44 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->priv->redo_btn);
#line 45 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->priv->undo_btn);
#line 47 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	_g_object_unref0 (self->window_settings);
#line 26 "/builddir/build/BUILD/photos-0.2.5/src/AppWindow.vala"
	G_OBJECT_CLASS (app_window_parent_class)->finalize (obj);
#line 3764 "AppWindow.c"
}


GType
app_window_get_type (void)
{
	static volatile gsize app_window_type_id__volatile = 0;
	if (g_once_init_enter (&app_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AppWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) app_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AppWindow), 0, (GInstanceInitFunc) app_window_instance_init, NULL };
		GType app_window_type_id;
		app_window_type_id = g_type_register_static (TYPE_PAGE_WINDOW, "AppWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		AppWindow_private_offset = g_type_add_instance_private (app_window_type_id, sizeof (AppWindowPrivate));
		g_once_init_leave (&app_window_type_id__volatile, app_window_type_id);
	}
	return app_window_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



